1
0
mirror of git://git.sv.gnu.org/coreutils.git synced 2026-07-28 19:39:52 +02:00
Files
coreutils/tests/misc/timeout
T

60 lines
1.7 KiB
Bash
Raw Normal View History

2008-03-28 11:05:55 +00:00
#!/bin/sh
# Validate timeout basic operation
# Copyright (C) 2008-2011 Free Software Foundation, Inc.
2008-03-28 11:05:55 +00:00
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
# You should have received a copy of the GNU General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
. "${srcdir=.}/init.sh"; path_prepend_ ../src
print_ver_ timeout
2008-03-28 11:05:55 +00:00
# no timeout
2010-02-02 10:47:48 +00:00
timeout 10 true || fail=1
2008-03-28 11:05:55 +00:00
# no timeout (suffix check)
timeout 1d true || fail=1
# disabled timeout
timeout 0 true || fail=1
# exit status propagation
2010-02-02 10:47:48 +00:00
timeout 10 sh -c 'exit 2'
2009-10-23 08:54:53 -06:00
test $? = 2 || fail=1
2008-03-28 11:05:55 +00:00
# timeout
2010-02-02 10:47:48 +00:00
timeout 1 sleep 10
2008-06-09 16:10:47 +01:00
test $? = 124 || fail=1
2008-03-28 11:05:55 +00:00
2010-03-15 23:03:30 +00:00
# kill delay. Note once the initial timeout triggers,
# the exit status will be 124 even if the command
# exits on its own accord.
timeout -s0 -k1 1 sleep 10
test $? = 124 && fail=1
# Ensure `timeout` is immune to parent's SIGCHLD handler
# Use a subshell and an exec to work around a bug in FreeBSD 5.0 /bin/sh.
(
# ash doesn't support "trap '' CHLD"; it knows only signal numbers.
sig=`"$abs_top_builddir/src/kill" -l CHLD 2>/dev/null` && trap '' $sig
2010-02-02 10:47:48 +00:00
exec timeout 10 true
) || fail=1
2011-07-17 12:47:22 -07:00
# Don't be confused when starting off with a child (Bug#9098).
out=$(sleep 1 & exec timeout 2 sh -c 'sleep 3; echo foo')
status=$?
test "$out" = "" && test $status = 124 || fail=1
Exit $fail